﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If System.IO.File.Exists(Application.StartupPath + "\grid.xml") = False Then
            Me.CreateXMLFile()
        End If

        Dim ds As New DataSet("Main")

        ds.ReadXml(Application.StartupPath + "\grid.xml")

        UltraGrid1.DisplayLayout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True
        UltraGrid1.DisplayLayout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow

        UltraGrid1.DataSource = ds
        UltraGrid1.DataBind()
    End Sub

    Private Sub UltraButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UltraButton1.Click
        Dim sw As Stopwatch = Stopwatch.StartNew()

        UltraGridExcelExporter1.OutliningStyle = Infragistics.Win.UltraWinGrid.ExcelExport.OutliningStyle.RaiseExceptionOnDepthOverflow
        UltraGridExcelExporter1.Export(UltraGrid1, Application.StartupPath + "\export.xls")
        'UltraGridExcelExporter1.Export(UltraGrid1, Application.StartupPath + "\export.xlsx")

        sw.Stop()
        MessageBox.Show(sw.Elapsed.TotalSeconds)
    End Sub

    Private Sub CreateXMLFile()
        Dim Writer As New Xml.XmlTextWriter(Application.StartupPath + "\grid.xml", System.Text.Encoding.UTF8)

        Writer.WriteStartDocument()
        Writer.Formatting = Xml.Formatting.Indented
        Writer.Indentation = 2
        Writer.WriteStartElement("NewDataSet")

        For i As Integer = 1 To 10000
            Writer.WriteStartElement("Node1")
            Writer.WriteStartElement("Node1_ID")
            Writer.WriteString(i.ToString)
            Writer.WriteEndElement()
            Writer.WriteStartElement("Node1_Name")
            Writer.WriteString("Node 1 - Element " + i.ToString)
            Writer.WriteEndElement()

            For j As Integer = 1 To 20
                Writer.WriteStartElement("Node2")
                Writer.WriteStartElement("Node2_ID")
                Writer.WriteString(j.ToString)
                Writer.WriteEndElement()
                Writer.WriteStartElement("Node2_Name")
                Writer.WriteString("Node 2 - Element " + j.ToString)
                Writer.WriteEndElement()
                Writer.WriteEndElement()
            Next


            Writer.WriteEndElement()
        Next i

        Writer.WriteEndElement()
        Writer.WriteEndDocument()
        Writer.Close()
    End Sub

End Class